Panda3D

Public Member Functions | List of all members
TiXmlDocument Class Reference

Always the top level node. More...

`#include "tinyxml.h"`

Inheritance diagram for TiXmlDocument:

## Public Member Functions
| TiXmlDocument ()
| Create an empty document, that has no name. More...
| TiXmlDocument (const char *documentName)
| Create a document with a name. The name of the document is also the filename of the xml. More...
| TiXmlDocument (const TiXmlDocument &copy)
virtual bool | Accept (TiXmlVisitor *content) const
| Walk the XML tree visiting this node and all of its children. More...
void | ClearError ()
| If you have handled the error, it can be reset with this call. More...
bool | Error () const
| If an error occurs, Error will be set to true. More...
int | ErrorCol () const
| The column where the error occured. See ErrorRow() More...
const char * | ErrorDesc () const
| Contains a textual (english) description of the error if one occurs. More...
int | ErrorId () const
| Generally, you probably want the error string ( ErrorDesc() ). More...
int | ErrorRow () const
| Returns the location (if known) of the error. More...
bool | LoadFile (const char *filename, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the given filename. Returns true if successful. More...
bool | LoadFile (FILE *, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the given FILE*. More...
bool | LoadFile (TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the current document value. More...
void | operator= (const TiXmlDocument &copy)
virtual const char * | Parse (const char *p, TiXmlParsingData *data=0, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Parse the given null terminated block of xml data. More...
void | Print () const
| Write the document to standard out using formatted printing ("pretty print"). More...
virtual void | Print (FILE *cfile, int depth=0) const
| Print this Document to a FILE stream. More...
TiXmlElement * | RootElement ()
const TiXmlElement * | RootElement () const
| Get the root element – the only top level element – of the document. More...
bool | SaveFile () const
| Save a file using the current document value. Returns true if successful. More...
bool | SaveFile (const char *filename) const
| Save a file using the given filename. Returns true if successful. More...
bool | SaveFile (FILE *) const
| Save a file using the given FILE*. Returns true if successful. More...
void | SetError (int err, const char *errorLocation, TiXmlParsingData *prevData, TiXmlEncoding encoding)
void | SetTabSize (int _tabsize)
| SetTabSize() allows the error reporting functions (ErrorRow() and ErrorCol()) to report the correct values for row and column. More...
int | TabSize () const
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null not of the requested type. More...
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type. More...
Public Member Functions inherited from TiXmlNode
void | Clear ()
| Delete all the children of this node. Does not affect 'this'. More...
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children. More...
TiXmlNode * | FirstChild (const char *_value)
| The first child of this node with the matching 'value'. Will be null if none found. More...
const TiXmlNode * | FirstChild (const char *value) const
| The first child of this node with the matching 'value'. More...
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement (const char *_value)
const TiXmlElement * | FirstChildElement (const char *_value) const
| Convenience function to get through elements. More...
TiXmlDocument * | GetDocument ()
const TiXmlDocument * | GetDocument () const
| Return a pointer to the Document this node lives in. More...
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
| Add a new node related to this. More...
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
| Add a new node related to this. More...
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
| Add a new node related to this. More...
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'. More...
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
| An alternate way to walk the children of a node. More...
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children. More...
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild (const char *_value)
| The last child of this node matching 'value'. Will be null if there are no children. More...
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
| Add a new node related to this. More...
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node. More...
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'. More...
TiXmlNode * | NextSibling (const char *_next)
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement () const
| Convenience function to get through elements. More...
const TiXmlElement * | NextSiblingElement (const char *) const
| Convenience function to get through elements. More...
TiXmlElement * | NextSiblingElement (const char *_next)
bool | NoChildren () const
| Returns true if this node has no children. More...
TiXmlNode * | Parent ()
| One step up the DOM. More...
const TiXmlNode * | Parent () const
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node. More...
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling (const char *_prev)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node. More...
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
| Replace a child of this node. More...
void | SetValue (const char *_value)
| Changes the value of the node. More...
virtual TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlText * | ToText ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null if not of the requested type. More...
int | Type () const
| Query the type (as an enumerated value, above) of this node. More...
const char * | Value () const
| The meaning of 'value' changes for the specific type of TiXmlNode. More...
const TiXmlString & | ValueTStr () const
Public Member Functions inherited from TiXmlBase
int | Column () const
| See Row() More...
void * | GetUserData ()
| Get a pointer to arbitrary user data. More...
const void * | GetUserData () const
| Get a pointer to arbitrary user data. More...
int | Row () const
| Return the position, in the original source file, of this node or attribute. More...
void | SetUserData (void *user)
| Set a pointer to arbitrary user data. More...

## Additional Inherited Members
Public Types inherited from TiXmlNode
enum | NodeType { TINYXML_DOCUMENT , TINYXML_ELEMENT , TINYXML_COMMENT , TINYXML_UNKNOWN , TINYXML_TEXT , TINYXML_DECLARATION , TINYXML_TYPECOUNT }
| The types of XML nodes supported by TinyXml. More...
Public Types inherited from TiXmlBase
enum | { TIXML_NO_ERROR = 0 , TIXML_ERROR , TIXML_ERROR_OPENING_FILE , TIXML_ERROR_PARSING_ELEMENT , TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME , TIXML_ERROR_READING_ELEMENT_VALUE , TIXML_ERROR_READING_ATTRIBUTES , TIXML_ERROR_PARSING_EMPTY , TIXML_ERROR_READING_END_TAG , TIXML_ERROR_PARSING_UNKNOWN , TIXML_ERROR_PARSING_COMMENT , TIXML_ERROR_PARSING_DECLARATION , TIXML_ERROR_DOCUMENT_EMPTY , TIXML_ERROR_EMBEDDED_NULL , TIXML_ERROR_PARSING_CDATA , TIXML_ERROR_DOCUMENT_TOP_ONLY , TIXML_ERROR_STRING_COUNT }
Static Public Member Functions inherited from TiXmlBase
static void | EncodeString (const TiXmlString &str, TiXmlString *out)
| Expands entities in a string. More...
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting. More...
static void | SetCondenseWhiteSpace (bool condense)
| The world does not agree on whether white space should be kept or not. More...
Static Public Attributes inherited from TiXmlBase
static const int | utf8ByteTable [256]

## Detailed Description

Always the top level node.

A document binds together all the XML pieces. It can be saved, loaded, and printed to the screen. The 'value' of a document node is the xml file name.

Definition at line 1386 of file tinyxml.h.

## Constructor & Destructor Documentation

## ◆ TiXmlDocument() [1/2]

TiXmlDocument::TiXmlDocument | ( |  | ) |

Create an empty document, that has no name.

Definition at line 891 of file tinyxml.cpp.

References ClearError().

## ◆ TiXmlDocument() [2/2]

TiXmlDocument::TiXmlDocument | ( | const char * | documentName | ) |

Create a document with a name. The name of the document is also the filename of the xml.

Definition at line 898 of file tinyxml.cpp.

References ClearError().

## Member Function Documentation

## ◆ Accept()

bool TiXmlDocument::Accept | ( | TiXmlVisitor * | content | ) | const
| virtual

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

Definition at line 1133 of file tinyxml.cpp.

References TiXmlNode::Accept(), TiXmlNode::FirstChild(), TiXmlNode::NextSibling(), TiXmlVisitor::VisitEnter(), and TiXmlVisitor::VisitExit().

## ◆ ClearError()

void TiXmlDocument::ClearError | ( |  | ) |
| inline

If you have handled the error, it can be reset with this call.

The error state is automatically cleared if you Parse a new XML block.

Definition at line 1504 of file tinyxml.h.

Referenced by TiXmlDocument(), and Parse().

## ◆ Error()

bool TiXmlDocument::Error | ( |  | ) | const
| inline

If an error occurs, Error will be set to true.

Also,

- The ErrorId() will contain the integer identifier of the error (not generally useful)
- The ErrorDesc() method will return the name of the error. (very useful)
- The ErrorRow() and ErrorCol() will return the location of the error (if known)

Definition at line 1453 of file tinyxml.h.

Referenced by LoadFile().

## ◆ ErrorCol()

int TiXmlDocument::ErrorCol | ( |  | ) | const
| inline

The column where the error occured. See ErrorRow()

Definition at line 1471 of file tinyxml.h.

## ◆ ErrorDesc()

const char* TiXmlDocument::ErrorDesc | ( |  | ) | const
| inline

Contains a textual (english) description of the error if one occurs.

Definition at line 1456 of file tinyxml.h.

## ◆ ErrorId()

int TiXmlDocument::ErrorId | ( |  | ) | const
| inline

Generally, you probably want the error string ( ErrorDesc() ).

But if you prefer the ErrorId, this function will fetch it.

Definition at line 1461 of file tinyxml.h.

## ◆ ErrorRow()

int TiXmlDocument::ErrorRow | ( |  | ) | const
| inline

Returns the location (if known) of the error.

The first column is column 1, and the first row is row 1. A value of 0 means the row and column wasn't applicable (memory errors, for example, have no row/column) or the parser lost the error. (An error in the error reporting, in that case.)

See also
  SetTabSize, Row, Column

Definition at line 1470 of file tinyxml.h.

## ◆ LoadFile() [1/3]

bool TiXmlDocument::LoadFile | ( | const char * | filename,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |

Load a file using the given filename. Returns true if successful.

Definition at line 942 of file tinyxml.cpp.

References LoadFile().

## ◆ LoadFile() [2/3]

bool TiXmlDocument::LoadFile | ( | FILE * | file,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |

Load a file using the given FILE*.

Returns true if successful. Note that this method doesn't stream - the entire object pointed at by the FILE* will be interpreted as an XML file. TinyXML doesn't stream in XML from the current file location. Streaming may be added in the future.

Definition at line 963 of file tinyxml.cpp.

References TiXmlNode::Clear(), Error(), and Parse().

## ◆ LoadFile() [3/3]

bool TiXmlDocument::LoadFile | ( | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` | ) |

Load a file using the current document value.

Returns true if successful. Will delete any existing document data before loading.

Definition at line 931 of file tinyxml.cpp.

References TiXmlNode::Value().

Referenced by LoadFile().

## ◆ Parse()

const char * TiXmlDocument::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data = `0`,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |
| virtual

Parse the given null terminated block of xml data.

Passing in an encoding to this method (either TIXML_ENCODING_LEGACY or TIXML_ENCODING_UTF8 will force TinyXml to use that encoding, regardless of what TinyXml might otherwise try to detect.

Implements TiXmlBase.

Definition at line 704 of file tinyxmlparser.cpp.

References ClearError().

Referenced by LoadFile().

## ◆ Print() [1/2]

void TiXmlDocument::Print | ( |  | ) | const
| inline

Write the document to standard out using formatted printing ("pretty print").

Definition at line 1512 of file tinyxml.h.

References Print().

Referenced by Print(), and SaveFile().

## ◆ Print() [2/2]

void TiXmlDocument::Print | ( | FILE * | cfile,
|  | int | depth = `0`
| ) |  | const
| virtual

Print this Document to a FILE stream.

Implements TiXmlBase.

Definition at line 1122 of file tinyxml.cpp.

References TiXmlNode::FirstChild(), TiXmlNode::NextSibling(), and TiXmlBase::Print().

## ◆ RootElement()

const TiXmlElement* TiXmlDocument::RootElement | ( |  | ) | const
| inline

Get the root element – the only top level element – of the document.

In well formed XML, there should only be one. TinyXml is tolerant of multiple elements at the document level.

Definition at line 1445 of file tinyxml.h.

References TiXmlNode::FirstChildElement().

## ◆ SaveFile() [1/3]

bool TiXmlDocument::SaveFile | ( |  | ) | const

Save a file using the current document value. Returns true if successful.

Definition at line 937 of file tinyxml.cpp.

References TiXmlNode::Value().

Referenced by SaveFile().

## ◆ SaveFile() [2/3]

bool TiXmlDocument::SaveFile | ( | const char * | filename | ) | const

Save a file using the given filename. Returns true if successful.

Definition at line 1061 of file tinyxml.cpp.

References SaveFile().

## ◆ SaveFile() [3/3]

bool TiXmlDocument::SaveFile | ( | FILE * | fp | ) | const

Save a file using the given FILE*. Returns true if successful.

Definition at line 1075 of file tinyxml.cpp.

References Print().

## ◆ SetTabSize()

void TiXmlDocument::SetTabSize | ( | int | _tabsize | ) |
| inline

SetTabSize() allows the error reporting functions (ErrorRow() and ErrorCol()) to report the correct values for row and column.

It does not change the output or input in any way.

By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded. Very useful for tracking the DOM back in to the source file.

The tab size is required for calculating the location of nodes. If not set, the default of 4 is used. The tabsize is set per document. Setting the tabsize to 0 disables row/column tracking.

Note that row and column tracking is not supported when using operator>>.

The tab size needs to be enabled before the parse or load. Correct usage:

    TiXmlDocument doc;
    doc.SetTabSize( 8 );
    doc.Load( "myfile.xml" );

See also
  Row, Column

Definition at line 1497 of file tinyxml.h.

## ◆ ToDocument() [1/2]

virtual TiXmlDocument* TiXmlDocument::ToDocument | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

Definition at line 1526 of file tinyxml.h.

## ◆ ToDocument() [2/2]

virtual const TiXmlDocument* TiXmlDocument::ToDocument | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

Definition at line 1525 of file tinyxml.h.

The documentation for this class was generated from the following files:

- panda/src/dxml/tinyxml.h
- panda/src/dxml/tinyxml.cpp
- panda/src/dxml/tinyxmlparser.cpp